{% extends 'base.html' %}

{% load bootstrap4 %}
{% load static %}
{% load project_extras %}
{% load icons %}

{% block title %}Project{% endblock %}


{% block content %}
    <h3 class="my-3">{{ project.title }}</h3>
    <p>Project status: {{ project.get_status_display }}</p>

    <p>Project total budget: {{ total_budget }}</p>
    <h3>Description</h3>
    <p class="project-description">{{ project.description }}</p>
    <h4>Category: {{ project.category }}</h4>


    {% if user.is_authenticated %}
        {% if user == project.user.user %}

            {% if project.status == project.OPEN %}

                <h3 class="my-3">Tasks:</h3>
                <div id="task_container">
                    {% for task in tasks %}
                        <div class="task">
                            <h4>{{ task.title }}</h4>
                            <p>Budget: {{ task.budget }} </p>
                            <p>Description: <br> {{ task.description }}</p>
                        </div>
                    {% endfor %}
                </div>


                <h3 class="my-3">Filtering and sorting</h3>
                <form method="get" name="filter-and-sort" class="filter-and-sort">
                    {% csrf_token %}
                    <div class="filter-item">
                        <div>
                            <h5>Price</h5>
                        </div>
                        <div>
                            <input type="range" name="price-filter" id="priceInputId" value="{{ price_filter }}" min="1"
                                   max="{{ max_offer }}"
                                   oninput="priceOutputId.value = priceInputId.value">
                        </div>
                        <div class="priceOutputId">
                            <output name="priceOutputName" id="priceOutputId">{{ price_filter }}</output>
                        </div>
                    </div>
                    <div class="filter-item">
                        <div>
                            <h5>Rating</h5>
                        </div>
                        <div class="rating rating-filter">
                            <input type="radio" name="rating-filter" value="5"
                                   id="filter_rating5" {% if rating_filter == 5 %} checked="checked" {% endif %}><label
                                for="filter_rating5"></label>
                            <input type="radio" name="rating-filter" value="4"
                                   id="filter_rating4" {% if rating_filter == 4 %} checked="checked" {% endif %}><label
                                for="filter_rating4"></label>
                            <input type="radio" name="rating-filter" value="3"
                                   id="filter_rating3" {% if rating_filter == 3 %} checked="checked" {% endif %}><label
                                for="filter_rating3"></label>
                            <input type="radio" name="rating-filter" value="2"
                                   id="filter_rating2" {% if rating_filter == 2 %} checked="checked" {% endif %}><label
                                for="filter_rating2"></label>
                            <input type="radio" name="rating-filter" value="1"
                                   id="filter_rating1" {% if rating_filter == 1 %} checked="checked" {% endif %}><label
                                for="filter_rating1"></label>
                        </div>
                    </div>
                    <div class="filter-item">
                        <div>
                            <h5>Order by</h5>
                        </div>
                        <select id="order-by" name="order-by" class="select-css">
                            <option selected="{{ order_by }}">{{ order_by|capfirst }}</option>
                            <option value="newest">Newest</option>
                            <option value="oldest">Oldest</option>
                            <option value="price">Price</option>
                            <option value="rating">Rating</option>
                        </select>
                    </div>
                    <div>
                        <div>
                            <h5></h5>
                        </div>
                        <div>
                            <button type="submit" class="btn btn-primary apply_filter" name="apply_filter">Apply
                            </button>
                        </div>
                    </div>
                </form>

                {% for task in tasks %}
                    {% define task|get_all_taskoffers as task_offers %}
                    {% if task|get_accepted_task_offer %}
                        {% define task|get_accepted_task_offer as task_accepted_offer %}

                        <h3 class="my-3">Accepted offer for <i>{{ task.title }}</i></h3>

                        <li class="list-group-item d-flex justify-content-between align-items-center">
                            <div class="tool-tip">Offer from {{ task_accepted_offer.offerer.user.username }}
                                <span class="tool-tip-text">
                                    {% if task_accepted_offer.offerer.rated_tasks and task_accepted_offer.offerer.rating %}
                                        Average rating over {{ task_accepted_offer.offerer.rated_tasks }}
                                        task{% if task_accepted_offer.offerer.rated_tasks > 1 %}s
                                        {% endif %}:
                                        {{ task_accepted_offer.offerer.rating }}
                                    {% else %}
                                        No rating received yet.
                                    {% endif %}
                                </span>
                            </div>
                            <div>
                                Status: {{ task_accepted_offer.get_status_display }}
                            </div>
                            <div>
                                Price offered: {{ task_accepted_offer.price }}kr
                            </div>
                            <div>
                                <button class="btn btn-primary btn-width" data-toggle="modal"
                                        data-target="#seeOfferModal{{ task_offer.id }}">View Offer
                                </button>
                                <div>
                        </li>

                        <div class="modal fade" id="seeOfferModal{{ task_offer.id }}" tabindex="-1" role="dialog"
                             aria-labelledby="seeOfferModal{{ task_offer.id }}Title" aria-hidden="true">
                            <div class="modal-dialog modal-dialog-centered" role="document">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="seeOfferModalTitle{{ task_offer.id }}">Offer
                                            for {{ task.title }}</h5>
                                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                    <form method="post">
                                        <div class="modal-body">
                                            <h3>Offer</h3>
                                            <h4 class="mt-3">{{ task_accepted_offer.title }}</h4>
                                            <p>Status: {{ task_accepted_offer.get_status_display }}</p>
                                            <p>Description: <br> {{ task_accepted_offer.description }}</p>
                                            <p>Price offered: {{ task_accepted_offer.price }} </p>
                                            <p class="mt-2">Feedback given: <br> {{ task_accepted_offer.feedback }}</p>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>

                    {% else %}
                        <h3 class="my-3">Pending offers for <i>{{ task.title }}</i></h3>
                        <p>Accepting one offer will remove all other pending offers.</p>
                        {% if order_by == 'oldest' %}
                            {% for task_offer in task.order_by_date_asc %}
                                {% include "projects/task_offers.html" %}
                            {% endfor %}
                        {% elif order_by == 'price' %}
                            {% for task_offer in task.order_by_price %}
                                {% include "projects/task_offers.html" %}
                            {% endfor %}
                        {% elif order_by == 'rating' %}
                            {% for task_offer in task.order_by_rating %}
                                {% include "projects/task_offers.html" %}
                            {% endfor %}
                        {% else %}
                            {% for task_offer in task.order_by_date_desc %}
                                {% include "projects/task_offers.html" %}
                            {% endfor %}
                        {% endif %}

                    {% endif %}
                {% endfor %}


            {% else %}

                <p>Project participants: {{ project|get_project_participants_string }}</p>

                <h3 class="mb-3">List of Tasks</h3>
                <div class="list-group">
                    {% for task in tasks %}
                        {% define task|get_accepted_task_offer as task_accepted_offer %}
                        <a href="{% url 'task_view' project_id=project.id task_id=task.id %}"
                           class="list-group-item list-group-item-action flex-column align-items-start my-1">
                            <div class="d-flex w-100 justify-content-between align-items-center">
                                <h5 class="mb-1">{% icon 'tasks' %} {{ task.title }}</h5>
                            </div>
                            <div class="d-flex">
                                <div>
                                    <p class="mb-1">Task status: {{ task.get_status_display }}</p>
                                </div>
                                <div class="ml-5">
                                    <p class="mb-1">Solver: {{ task_accepted_offer.offerer.user.username }} </p>
                                </div>
                            </div>
                        </a>
                        {% if task.status == 'pp' or task.status == 'ps' %}
                            {% if not task.task_rating %}
                                <button type="button" class="btn btn-primary btn-width btn-bottom-margin" data-toggle="modal"
                                        data-target="#rating-modal{{ task.id }}">Give a rating
                                </button>
                            {% else %}
                                <button type="button" class="btn btn-secondary btn-width btn-bottom-margin" disabled>Thanks for your rating</button>
                            {% endif %}
                        {% endif %}
                        <div class="modal fade" role="dialog" id="rating-modal{{ task.id }}">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <div class="modal-title">Give an assessment of {{ task.title }}</div>
                                        <button type="button" class="close" data-dismiss="modal">&times</button>
                                    </div>

                                    <div class="modal-body">
                                        <div class="form-group">
                                            <div class="form-row">
                                                <p>Tell us how it went so others can make a better choice!</p>
                                            </div>
                                            <form name="task_review" method="post">
                                                {% csrf_token %}
                                                <div class="form-row">
                                                    <div class="modal-sub-header">How satisfied are you?</div>
                                                    <div class="rating">
                                                        <input type="radio" name="rating" value="5"
                                                               id="star5-{{ task.id }}" required><label
                                                            for="star5-{{ task.id }}"></label>
                                                        <input type="radio" name="rating" value="4"
                                                               id="star4-{{ task.id }}"><label
                                                            for="star4-{{ task.id }}"></label>
                                                        <input type="radio" name="rating" value="3"
                                                               id="star3-{{ task.id }}"><label
                                                            for="star3-{{ task.id }}"></label>
                                                        <input type="radio" name="rating" value="2"
                                                               id="star2-{{ task.id }}"><label
                                                            for="star2-{{ task.id }}"></label>
                                                        <input type="radio" name="rating" value="1"
                                                               id="star1-{{ task.id }}"><label
                                                            for="star1-{{ task.id }}"></label>
                                                    </div>
                                                </div>

                                                <div class="form-row">
                                                    <div class="modal-sub-header margin">
                                                        Write a review
                                                        of {{ task_accepted_offer.offerer.user.username }}
                                                    </div>
                                                    <textarea class="text-area" rows="4" name="description"
                                                              placeholder=""></textarea>
                                                </div>
                                                <input type="hidden" name="task_id" value="{{ task.id }}">
                                                <input type="hidden" name="customer_id" value="{{ user.id }}">
                                                <input type="hidden" name="project_manager_id"
                                                       value="{{ task_accepted_offer.offerer.user.id }}">
                                                <div class="modal-footer">
                                                    <button type="submit" name='task_review'
                                                            class="btn btn-primary">
                                                        Submit
                                                    </button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}

                </div>


            {% endif %}

            <div class="hide-label">
                <h3 class="mb-3">Change project status</h3>
                <form method="post">
                    {% csrf_token %}
                    {% bootstrap_form status_form %}
                    <button class="btn btn-primary btn-width" name="status_change" type="submit">Change status</button>
                </form>
            </div>

        {% else %}



            {% if project.status == project.OPEN %}

                <h3 class="my-3">Tasks:</h3>
                <div id="task_container">
                    {% for task in tasks %}
                        <div class="task">
                            <h4>{{ task.title }}</h4>
                            <p>Budget: {{ task.budget }} </p>
                            <p>Description: <br> {{ task.description }}</p>
                        </div>
                    {% endfor %}
                </div>

                <h2 class="my-3">Make an offer</h2>
                <ul class="list-group">
                    {% for task in tasks %}
                        {% define task|check_taskoffers:user as task_user_offers %}
                        {% if task_user_offers %}

                            {% with offer=task_user_offers|last %}

                                <li class="list-group-item d-flex justify-content-between align-items-center">{{ task.title }}
                                    <div>
                                        <label>Status:</label>
                                        <button class="btn {% if offer.status == offer.PENDING %} btn-warning {% elif offer.status == 'a' %} btn-success {% else %} btn-danger {% endif %}"
                                                data-toggle="modal"
                                                data-target="#makeOfferModal{{ task.id }}">{{ offer.get_status_display }}</button>
                                        <div>
                                </li>

                                <div class="modal fade" id="makeOfferModal{{ task.id }}" tabindex="-1" role="dialog"
                                     aria-labelledby="makeOfferModal{{ task.id }}Title" aria-hidden="true">
                                    <div class="modal-dialog modal-dialog-centered" role="document">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="makeOfferModalTitle{{ task.id }}">Make an
                                                    offer for {{ task.title }}</h5>
                                                <button type="button" class="close" data-dismiss="modal"
                                                        aria-label="Close">
                                                    <span aria-hidden="true">&times;</span>
                                                </button>
                                            </div>
                                            <form method="post">
                                                <div class="modal-body">
                                                    <h3>Last Offer </h3>
                                                    <h4 class="mt-3">{{ offer.title }}</h4>
                                                    <p>Status: {{ offer.get_status_display }}</p>
                                                    <p>Description: <br> {{ offer.description }}</p>
                                                    <p>Price offered: {{ offer.price }} </p>
                                                    {% if offer.status == 'a' or offer.status == 'd' %}
                                                        <p class="mt-2">Feedback from project owner:
                                                            <br> {{ offer.feedback }}</p>
                                                    {% endif %}

                                                    {% if offer.status == 'd' %}
                                                        <h3 class="mt-3">Make New Offer</h3>
                                                        {% csrf_token %}
                                                        {% bootstrap_form task_offer_form %}
                                                        <input type="hidden" name="taskvalue" value="{{ task.id }}">
                                                    {% endif %}
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-secondary"
                                                            data-dismiss="modal">Close
                                                    </button>
                                                    {% if offer.status == 'd' %}
                                                        <button type="submit" name="offer_submit"
                                                                class="btn btn-primary">Send New Offer
                                                        </button>
                                                    {% endif %}
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>

                            {% endwith %}

                        {% else %}

                            <li class="list-group-item d-flex justify-content-between align-items-center">{{ task.title }}
                                <button class="btn btn-primary" data-toggle="modal"
                                        data-target="#makeOfferModal{{ task.id }}">Make Offer
                                </button>
                            </li>

                            <div class="modal fade" id="makeOfferModal{{ task.id }}" tabindex="-1" role="dialog"
                                 aria-labelledby="makeOfferModal{{ task.id }}Title" aria-hidden="true">
                                <div class="modal-dialog modal-dialog-centered" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="makeOfferModalTitle{{ task.id }}">Make an offer
                                                for {{ task.title }}</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <form method="post">
                                            <div class="modal-body">
                                                {% csrf_token %}
                                                {% bootstrap_form task_offer_form %}
                                                <input type="hidden" name="taskvalue" value="{{ task.id }}">
                                            </div>
                                            <div class="modal-footer">
                                                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                                                    Close
                                                </button>
                                                <button type="submit" name="offer_submit" class="btn btn-primary">Send
                                                    Offer
                                                </button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>

                        {% endif %}
                    {% endfor %}

                </ul>

            {% else %}

                <h3 class="mb-3 mt-5">Tasks you have access to</h3>
                <div class="list-group">
                    {% for task in tasks %}
                        <a href="{% url 'task_view' project_id=project.id task_id=task.id %}"
                           class="list-group-item list-group-item-action flex-column align-items-start my-1">
                            <div class="d-flex w-100 justify-content-between align-items-center">
                                <h5 class="mb-1">{% icon 'tasks' %} {{ task.title }}</h5>
                            </div>
                            <div class="d-flex">
                                <div>
                                    <p class="mb-1">Task status: {{ task.get_status_display }}</p>
                                </div>
                            </div>
                        </a>
                    {% endfor %}
                </div>

            {% endif %}

        {% endif %}

    {% endif %}
{% endblock %}
